Symlink mergetools scriptlets into valgrind wrappers
[git/mingw.git] / t / test-lib.sh
blobc210c17c2979565b66380f39f8b38fd9fa848a69
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22 # do not redirect again
24 *' --tee '*|*' --va'*)
25 mkdir -p test-results
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
30 exit
32 esac
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 EDITOR=:
45 unset VISUAL
46 unset EMAIL
47 unset $(perl -e '
48 my @env = keys %ENV;
49 my $ok = join("|", qw(
50 TRACE
51 DEBUG
52 USE_LOOKUP
53 TEST
54 .*_TEST
55 PROVE
56 VALGRIND
57 ));
58 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
59 print join("\n", @vars);
61 GIT_AUTHOR_EMAIL=author@example.com
62 GIT_AUTHOR_NAME='A U Thor'
63 GIT_COMMITTER_EMAIL=committer@example.com
64 GIT_COMMITTER_NAME='C O Mitter'
65 GIT_MERGE_VERBOSITY=5
66 export GIT_MERGE_VERBOSITY
67 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
68 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
69 export EDITOR
71 # Protect ourselves from common misconfiguration to export
72 # CDPATH into the environment
73 unset CDPATH
75 unset GREP_OPTIONS
77 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
78 1|2|true)
79 echo "* warning: Some tests will not work if GIT_TRACE" \
80 "is set as to trace on STDERR ! *"
81 echo "* warning: Please set GIT_TRACE to something" \
82 "other than 1, 2 or true ! *"
84 esac
86 # Convenience
88 # A regexp to match 5 and 40 hexdigits
89 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
90 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
92 # Zero SHA-1
93 _z40=0000000000000000000000000000000000000000
95 # Line feed
96 LF='
99 # Each test should start with something like this, after copyright notices:
101 # test_description='Description of this test...
102 # This test checks if command xyzzy does the right thing...
104 # . ./test-lib.sh
105 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
106 TERM=$ORIGINAL_TERM &&
107 export TERM &&
108 [ -t 1 ] &&
109 tput bold >/dev/null 2>&1 &&
110 tput setaf 1 >/dev/null 2>&1 &&
111 tput sgr0 >/dev/null 2>&1
112 ) &&
113 color=t
115 while test "$#" -ne 0
117 case "$1" in
118 -d|--d|--de|--deb|--debu|--debug)
119 debug=t; shift ;;
120 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
121 immediate=t; shift ;;
122 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
123 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
124 -h|--h|--he|--hel|--help)
125 help=t; shift ;;
126 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
127 verbose=t; shift ;;
128 -q|--q|--qu|--qui|--quie|--quiet)
129 # Ignore --quiet under a TAP::Harness. Saying how many tests
130 # passed without the ok/not ok details is always an error.
131 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
132 --with-dashes)
133 with_dashes=t; shift ;;
134 --no-color)
135 color=; shift ;;
136 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
137 valgrind=t; verbose=t; shift ;;
138 --tee)
139 shift ;; # was handled already
140 --root=*)
141 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
142 shift ;;
144 echo "error: unknown test option '$1'" >&2; exit 1 ;;
145 esac
146 done
148 if test -n "$color"; then
149 say_color () {
151 TERM=$ORIGINAL_TERM
152 export TERM
153 case "$1" in
154 error) tput bold; tput setaf 1;; # bold red
155 skip) tput bold; tput setaf 2;; # bold green
156 pass) tput setaf 2;; # green
157 info) tput setaf 3;; # brown
158 *) test -n "$quiet" && return;;
159 esac
160 shift
161 printf "%s" "$*"
162 tput sgr0
163 echo
166 else
167 say_color() {
168 test -z "$1" && test -n "$quiet" && return
169 shift
170 echo "$*"
174 error () {
175 say_color error "error: $*"
176 GIT_EXIT_OK=t
177 exit 1
180 say () {
181 say_color info "$*"
184 test "${test_description}" != "" ||
185 error "Test script did not set test_description."
187 if test "$help" = "t"
188 then
189 echo "$test_description"
190 exit 0
193 exec 5>&1
194 if test "$verbose" = "t"
195 then
196 exec 4>&2 3>&1
197 else
198 exec 4>/dev/null 3>/dev/null
201 test_failure=0
202 test_count=0
203 test_fixed=0
204 test_broken=0
205 test_success=0
207 test_external_has_tap=0
209 die () {
210 code=$?
211 if test -n "$GIT_EXIT_OK"
212 then
213 exit $code
214 else
215 echo >&5 "FATAL: Unexpected exit with code $code"
216 exit 1
220 GIT_EXIT_OK=
221 trap 'die' EXIT
223 # The semantics of the editor variables are that of invoking
224 # sh -c "$EDITOR \"$@\"" files ...
226 # If our trash directory contains shell metacharacters, they will be
227 # interpreted if we just set $EDITOR directly, so do a little dance with
228 # environment variables to work around this.
230 # In particular, quoting isn't enough, as the path may contain the same quote
231 # that we're using.
232 test_set_editor () {
233 FAKE_EDITOR="$1"
234 export FAKE_EDITOR
235 EDITOR='"$FAKE_EDITOR"'
236 export EDITOR
239 test_decode_color () {
240 awk '
241 function name(n) {
242 if (n == 0) return "RESET";
243 if (n == 1) return "BOLD";
244 if (n == 30) return "BLACK";
245 if (n == 31) return "RED";
246 if (n == 32) return "GREEN";
247 if (n == 33) return "YELLOW";
248 if (n == 34) return "BLUE";
249 if (n == 35) return "MAGENTA";
250 if (n == 36) return "CYAN";
251 if (n == 37) return "WHITE";
252 if (n == 40) return "BLACK";
253 if (n == 41) return "BRED";
254 if (n == 42) return "BGREEN";
255 if (n == 43) return "BYELLOW";
256 if (n == 44) return "BBLUE";
257 if (n == 45) return "BMAGENTA";
258 if (n == 46) return "BCYAN";
259 if (n == 47) return "BWHITE";
262 while (match($0, /\033\[[0-9;]*m/) != 0) {
263 printf "%s<", substr($0, 1, RSTART-1);
264 codes = substr($0, RSTART+2, RLENGTH-3);
265 if (length(codes) == 0)
266 printf "%s", name(0)
267 else {
268 n = split(codes, ary, ";");
269 sep = "";
270 for (i = 1; i <= n; i++) {
271 printf "%s%s", sep, name(ary[i]);
272 sep = ";"
275 printf ">";
276 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
278 print
283 nul_to_q () {
284 perl -pe 'y/\000/Q/'
287 q_to_nul () {
288 perl -pe 'y/Q/\000/'
291 q_to_cr () {
292 tr Q '\015'
295 q_to_tab () {
296 tr Q '\011'
299 append_cr () {
300 sed -e 's/$/Q/' | tr Q '\015'
303 remove_cr () {
304 tr '\015' Q | sed -e 's/Q$//'
307 # In some bourne shell implementations, the "unset" builtin returns
308 # nonzero status when a variable to be unset was not set in the first
309 # place.
311 # Use sane_unset when that should not be considered an error.
313 sane_unset () {
314 unset "$@"
315 return 0
318 test_tick () {
319 if test -z "${test_tick+set}"
320 then
321 test_tick=1112911993
322 else
323 test_tick=$(($test_tick + 60))
325 GIT_COMMITTER_DATE="$test_tick -0700"
326 GIT_AUTHOR_DATE="$test_tick -0700"
327 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
330 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
332 # This will commit a file with the given contents and the given commit
333 # message. It will also add a tag with <message> as name.
335 # Both <file> and <contents> default to <message>.
337 test_commit () {
338 file=${2:-"$1.t"}
339 echo "${3-$1}" > "$file" &&
340 git add "$file" &&
341 test_tick &&
342 git commit -m "$1" &&
343 git tag "$1"
346 # Call test_merge with the arguments "<message> <commit>", where <commit>
347 # can be a tag pointing to the commit-to-merge.
349 test_merge () {
350 test_tick &&
351 git merge -m "$1" "$2" &&
352 git tag "$1"
355 # This function helps systems where core.filemode=false is set.
356 # Use it instead of plain 'chmod +x' to set or unset the executable bit
357 # of a file in the working directory and add it to the index.
359 test_chmod () {
360 chmod "$@" &&
361 git update-index --add "--chmod=$@"
364 # Use test_set_prereq to tell that a particular prerequisite is available.
365 # The prerequisite can later be checked for in two ways:
367 # - Explicitly using test_have_prereq.
369 # - Implicitly by specifying the prerequisite tag in the calls to
370 # test_expect_{success,failure,code}.
372 # The single parameter is the prerequisite tag (a simple word, in all
373 # capital letters by convention).
375 test_set_prereq () {
376 satisfied="$satisfied$1 "
378 satisfied=" "
380 test_have_prereq () {
381 # prerequisites can be concatenated with ','
382 save_IFS=$IFS
383 IFS=,
384 set -- $*
385 IFS=$save_IFS
387 total_prereq=0
388 ok_prereq=0
389 missing_prereq=
391 for prerequisite
393 total_prereq=$(($total_prereq + 1))
394 case $satisfied in
395 *" $prerequisite "*)
396 ok_prereq=$(($ok_prereq + 1))
399 # Keep a list of missing prerequisites
400 if test -z "$missing_prereq"
401 then
402 missing_prereq=$prerequisite
403 else
404 missing_prereq="$prerequisite,$missing_prereq"
406 esac
407 done
409 test $total_prereq = $ok_prereq
412 test_declared_prereq () {
413 case ",$test_prereq," in
414 *,$1,*)
415 return 0
417 esac
418 return 1
421 # You are not expected to call test_ok_ and test_failure_ directly, use
422 # the text_expect_* functions instead.
424 test_ok_ () {
425 test_success=$(($test_success + 1))
426 say_color "" "ok $test_count - $@"
429 test_failure_ () {
430 test_failure=$(($test_failure + 1))
431 say_color error "not ok - $test_count $1"
432 shift
433 echo "$@" | sed -e 's/^/# /'
434 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
437 test_known_broken_ok_ () {
438 test_fixed=$(($test_fixed+1))
439 say_color "" "ok $test_count - $@ # TODO known breakage"
442 test_known_broken_failure_ () {
443 test_broken=$(($test_broken+1))
444 say_color skip "not ok $test_count - $@ # TODO known breakage"
447 test_debug () {
448 test "$debug" = "" || eval "$1"
451 test_eval_ () {
452 # This is a separate function because some tests use
453 # "return" to end a test_expect_success block early.
454 eval >&3 2>&4 "$*"
457 test_run_ () {
458 test_cleanup=:
459 expecting_failure=$2
460 test_eval_ "$1"
461 eval_ret=$?
463 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
464 then
465 test_eval_ "$test_cleanup"
467 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
468 echo ""
470 return "$eval_ret"
473 test_skip () {
474 test_count=$(($test_count+1))
475 to_skip=
476 for skp in $GIT_SKIP_TESTS
478 case $this_test.$test_count in
479 $skp)
480 to_skip=t
481 break
482 esac
483 done
484 if test -z "$to_skip" && test -n "$test_prereq" &&
485 ! test_have_prereq "$test_prereq"
486 then
487 to_skip=t
489 case "$to_skip" in
491 of_prereq=
492 if test "$missing_prereq" != "$test_prereq"
493 then
494 of_prereq=" of $test_prereq"
497 say_color skip >&3 "skipping test: $@"
498 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
499 : true
502 false
504 esac
507 test_expect_failure () {
508 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
509 test "$#" = 2 ||
510 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
511 export test_prereq
512 if ! test_skip "$@"
513 then
514 say >&3 "checking known breakage: $2"
515 if test_run_ "$2" expecting_failure
516 then
517 test_known_broken_ok_ "$1"
518 else
519 test_known_broken_failure_ "$1"
522 echo >&3 ""
525 test_expect_success () {
526 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
527 test "$#" = 2 ||
528 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
529 export test_prereq
530 if ! test_skip "$@"
531 then
532 say >&3 "expecting success: $2"
533 if test_run_ "$2"
534 then
535 test_ok_ "$1"
536 else
537 test_failure_ "$@"
540 echo >&3 ""
543 # test_external runs external test scripts that provide continuous
544 # test output about their progress, and succeeds/fails on
545 # zero/non-zero exit code. It outputs the test output on stdout even
546 # in non-verbose mode, and announces the external script with "# run
547 # <n>: ..." before running it. When providing relative paths, keep in
548 # mind that all scripts run in "trash directory".
549 # Usage: test_external description command arguments...
550 # Example: test_external 'Perl API' perl ../path/to/test.pl
551 test_external () {
552 test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
553 test "$#" = 3 ||
554 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
555 descr="$1"
556 shift
557 export test_prereq
558 if ! test_skip "$descr" "$@"
559 then
560 # Announce the script to reduce confusion about the
561 # test output that follows.
562 say_color "" "# run $test_count: $descr ($*)"
563 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
564 # to be able to use them in script
565 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
566 # Run command; redirect its stderr to &4 as in
567 # test_run_, but keep its stdout on our stdout even in
568 # non-verbose mode.
569 "$@" 2>&4
570 if [ "$?" = 0 ]
571 then
572 if test $test_external_has_tap -eq 0; then
573 test_ok_ "$descr"
574 else
575 say_color "" "# test_external test $descr was ok"
576 test_success=$(($test_success + 1))
578 else
579 if test $test_external_has_tap -eq 0; then
580 test_failure_ "$descr" "$@"
581 else
582 say_color error "# test_external test $descr failed: $@"
583 test_failure=$(($test_failure + 1))
589 # Like test_external, but in addition tests that the command generated
590 # no output on stderr.
591 test_external_without_stderr () {
592 # The temporary file has no (and must have no) security
593 # implications.
594 tmp=${TMPDIR:-/tmp}
595 stderr="$tmp/git-external-stderr.$$.tmp"
596 test_external "$@" 4> "$stderr"
597 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
598 descr="no stderr: $1"
599 shift
600 say >&3 "# expecting no stderr from previous command"
601 if [ ! -s "$stderr" ]; then
602 rm "$stderr"
604 if test $test_external_has_tap -eq 0; then
605 test_ok_ "$descr"
606 else
607 say_color "" "# test_external_without_stderr test $descr was ok"
608 test_success=$(($test_success + 1))
610 else
611 if [ "$verbose" = t ]; then
612 output=`echo; echo "# Stderr is:"; cat "$stderr"`
613 else
614 output=
616 # rm first in case test_failure exits.
617 rm "$stderr"
618 if test $test_external_has_tap -eq 0; then
619 test_failure_ "$descr" "$@" "$output"
620 else
621 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
622 test_failure=$(($test_failure + 1))
627 # debugging-friendly alternatives to "test [-f|-d|-e]"
628 # The commands test the existence or non-existence of $1. $2 can be
629 # given to provide a more precise diagnosis.
630 test_path_is_file () {
631 if ! [ -f "$1" ]
632 then
633 echo "File $1 doesn't exist. $*"
634 false
638 test_path_is_dir () {
639 if ! [ -d "$1" ]
640 then
641 echo "Directory $1 doesn't exist. $*"
642 false
646 test_path_is_missing () {
647 if [ -e "$1" ]
648 then
649 echo "Path exists:"
650 ls -ld "$1"
651 if [ $# -ge 1 ]; then
652 echo "$*"
654 false
658 # test_line_count checks that a file has the number of lines it
659 # ought to. For example:
661 # test_expect_success 'produce exactly one line of output' '
662 # do something >output &&
663 # test_line_count = 1 output
666 # is like "test $(wc -l <output) = 1" except that it passes the
667 # output through when the number of lines is wrong.
669 test_line_count () {
670 if test $# != 3
671 then
672 error "bug in the test script: not 3 parameters to test_line_count"
673 elif ! test $(wc -l <"$3") "$1" "$2"
674 then
675 echo "test_line_count: line count for $3 !$1 $2"
676 cat "$3"
677 return 1
681 # This is not among top-level (test_expect_success | test_expect_failure)
682 # but is a prefix that can be used in the test script, like:
684 # test_expect_success 'complain and die' '
685 # do something &&
686 # do something else &&
687 # test_must_fail git checkout ../outerspace
690 # Writing this as "! git checkout ../outerspace" is wrong, because
691 # the failure could be due to a segv. We want a controlled failure.
693 test_must_fail () {
694 "$@"
695 exit_code=$?
696 if test $exit_code = 0; then
697 echo >&2 "test_must_fail: command succeeded: $*"
698 return 1
699 elif test $exit_code -gt 129 -a $exit_code -le 192; then
700 echo >&2 "test_must_fail: died by signal: $*"
701 return 1
702 elif test $exit_code = 127; then
703 echo >&2 "test_must_fail: command not found: $*"
704 return 1
706 return 0
709 # Similar to test_must_fail, but tolerates success, too. This is
710 # meant to be used in contexts like:
712 # test_expect_success 'some command works without configuration' '
713 # test_might_fail git config --unset all.configuration &&
714 # do something
717 # Writing "git config --unset all.configuration || :" would be wrong,
718 # because we want to notice if it fails due to segv.
720 test_might_fail () {
721 "$@"
722 exit_code=$?
723 if test $exit_code -gt 129 -a $exit_code -le 192; then
724 echo >&2 "test_might_fail: died by signal: $*"
725 return 1
726 elif test $exit_code = 127; then
727 echo >&2 "test_might_fail: command not found: $*"
728 return 1
730 return 0
733 # Similar to test_must_fail and test_might_fail, but check that a
734 # given command exited with a given exit code. Meant to be used as:
736 # test_expect_success 'Merge with d/f conflicts' '
737 # test_expect_code 1 git merge "merge msg" B master
740 test_expect_code () {
741 want_code=$1
742 shift
743 "$@"
744 exit_code=$?
745 if test $exit_code = $want_code
746 then
747 return 0
750 echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
751 return 1
754 # test_cmp is a helper function to compare actual and expected output.
755 # You can use it like:
757 # test_expect_success 'foo works' '
758 # echo expected >expected &&
759 # foo >actual &&
760 # test_cmp expected actual
763 # This could be written as either "cmp" or "diff -u", but:
764 # - cmp's output is not nearly as easy to read as diff -u
765 # - not all diff versions understand "-u"
767 test_cmp() {
768 $GIT_TEST_CMP "$@"
771 # This function can be used to schedule some commands to be run
772 # unconditionally at the end of the test to restore sanity:
774 # test_expect_success 'test core.capslock' '
775 # git config core.capslock true &&
776 # test_when_finished "git config --unset core.capslock" &&
777 # hello world
780 # That would be roughly equivalent to
782 # test_expect_success 'test core.capslock' '
783 # git config core.capslock true &&
784 # hello world
785 # git config --unset core.capslock
788 # except that the greeting and config --unset must both succeed for
789 # the test to pass.
791 # Note that under --immediate mode, no clean-up is done to help diagnose
792 # what went wrong.
794 test_when_finished () {
795 test_cleanup="{ $*
796 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
799 # Most tests can use the created repository, but some may need to create more.
800 # Usage: test_create_repo <directory>
801 test_create_repo () {
802 test "$#" = 1 ||
803 error "bug in the test script: not 1 parameter to test-create-repo"
804 repo="$1"
805 mkdir -p "$repo"
807 cd "$repo" || error "Cannot setup test environment"
808 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
809 error "cannot run git init -- have you built things yet?"
810 mv .git/hooks .git/hooks-disabled
811 ) || exit
814 test_done () {
815 GIT_EXIT_OK=t
817 if test -z "$HARNESS_ACTIVE"; then
818 test_results_dir="$TEST_DIRECTORY/test-results"
819 mkdir -p "$test_results_dir"
820 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
822 cat >>"$test_results_path" <<-EOF
823 total $test_count
824 success $test_success
825 fixed $test_fixed
826 broken $test_broken
827 failed $test_failure
832 if test "$test_fixed" != 0
833 then
834 say_color pass "# fixed $test_fixed known breakage(s)"
836 if test "$test_broken" != 0
837 then
838 say_color error "# still have $test_broken known breakage(s)"
839 msg="remaining $(($test_count-$test_broken)) test(s)"
840 else
841 msg="$test_count test(s)"
843 case "$test_failure" in
845 # Maybe print SKIP message
846 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
848 if test $test_external_has_tap -eq 0; then
849 say_color pass "# passed all $msg"
850 say "1..$test_count$skip_all"
853 test -d "$remove_trash" &&
854 cd "$(dirname "$remove_trash")" &&
855 rm -rf "$(basename "$remove_trash")"
857 exit 0 ;;
860 if test $test_external_has_tap -eq 0; then
861 say_color error "# failed $test_failure among $msg"
862 say "1..$test_count"
865 exit 1 ;;
867 esac
870 # Test the binaries we have just built. The tests are kept in
871 # t/ subdirectory and are run in 'trash directory' subdirectory.
872 if test -z "$TEST_DIRECTORY"
873 then
874 # We allow tests to override this, in case they want to run tests
875 # outside of t/, e.g. for running tests on the test library
876 # itself.
877 TEST_DIRECTORY=$(pwd)
879 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
881 if test -n "$valgrind"
882 then
883 make_symlink () {
884 test -h "$2" &&
885 test "$1" = "$(readlink "$2")" || {
886 # be super paranoid
887 if mkdir "$2".lock
888 then
889 rm -f "$2" &&
890 ln -s "$1" "$2" &&
891 rm -r "$2".lock
892 else
893 while test -d "$2".lock
895 say "Waiting for lock on $2."
896 sleep 1
897 done
902 make_valgrind_symlink () {
903 # handle only executables, unless they are shell libraries that
904 # need to be in the exec-path. We will just use "#!" as a
905 # guess for a shell-script, since we have no idea what the user
906 # may have configured as the shell path.
907 test -x "$1" ||
908 test "#!" = "$(head -c 2 <"$1")" ||
909 return;
911 base=$(basename "$1")
912 symlink_target=$GIT_BUILD_DIR/$base
913 # do not override scripts
914 if test -x "$symlink_target" &&
915 test ! -d "$symlink_target" &&
916 test "#!" != "$(head -c 2 < "$symlink_target")"
917 then
918 symlink_target=../valgrind.sh
920 case "$base" in
921 *.sh|*.perl)
922 symlink_target=../unprocessed-script
923 esac
924 # create the link, or replace it if it is out of date
925 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
928 # override all git executables in TEST_DIRECTORY/..
929 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
930 mkdir -p "$GIT_VALGRIND"/bin
931 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
933 make_valgrind_symlink $file
934 done
935 # special-case the mergetools loadables
936 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
937 OLDIFS=$IFS
938 IFS=:
939 for path in $PATH
941 ls "$path"/git-* 2> /dev/null |
942 while read file
944 make_valgrind_symlink "$file"
945 done
946 done
947 IFS=$OLDIFS
948 PATH=$GIT_VALGRIND/bin:$PATH
949 GIT_EXEC_PATH=$GIT_VALGRIND/bin
950 export GIT_VALGRIND
951 elif test -n "$GIT_TEST_INSTALLED" ; then
952 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
953 error "Cannot run git from $GIT_TEST_INSTALLED."
954 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
955 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
956 else # normal case, use ../bin-wrappers only unless $with_dashes:
957 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
958 if ! test -x "$git_bin_dir/git" ; then
959 if test -z "$with_dashes" ; then
960 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
962 with_dashes=t
964 PATH="$git_bin_dir:$PATH"
965 GIT_EXEC_PATH=$GIT_BUILD_DIR
966 if test -n "$with_dashes" ; then
967 PATH="$GIT_BUILD_DIR:$PATH"
970 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
971 unset GIT_CONFIG
972 GIT_CONFIG_NOSYSTEM=1
973 GIT_ATTR_NOSYSTEM=1
974 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
976 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
978 if test -z "$GIT_TEST_CMP"
979 then
980 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
981 then
982 GIT_TEST_CMP="$DIFF -c"
983 else
984 GIT_TEST_CMP="$DIFF -u"
988 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
989 export GITPERLLIB
990 test -d "$GIT_BUILD_DIR"/templates/blt || {
991 error "You haven't built things yet, have you?"
994 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
995 then
996 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
997 export GITPYTHONLIB
998 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
999 error "You haven't built git_remote_helpers yet, have you?"
1003 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
1004 echo >&2 'You need to build test-chmtime:'
1005 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
1006 exit 1
1009 # Test repository
1010 test="trash directory.$(basename "$0" .sh)"
1011 test -n "$root" && test="$root/$test"
1012 case "$test" in
1013 /*) TRASH_DIRECTORY="$test" ;;
1014 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
1015 esac
1016 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
1017 rm -fr "$test" || {
1018 GIT_EXIT_OK=t
1019 echo >&5 "FATAL: Cannot prepare test area"
1020 exit 1
1023 HOME="$TRASH_DIRECTORY"
1024 export HOME
1026 test_create_repo "$test"
1027 # Use -P to resolve symlinks in our working directory so that the cwd
1028 # in subprocesses like git equals our $PWD (for pathname comparisons).
1029 cd -P "$test" || exit 1
1031 this_test=${0##*/}
1032 this_test=${this_test%%-*}
1033 for skp in $GIT_SKIP_TESTS
1035 case "$this_test" in
1036 $skp)
1037 say_color skip >&3 "skipping test $this_test altogether"
1038 skip_all="skip all tests in $this_test"
1039 test_done
1040 esac
1041 done
1043 # Provide an implementation of the 'yes' utility
1044 yes () {
1045 if test $# = 0
1046 then
1048 else
1049 y="$*"
1052 while echo "$y"
1055 done
1058 # Fix some commands on Windows
1059 case $(uname -s) in
1060 *MINGW*)
1061 # Windows has its own (incompatible) sort and find
1062 sort () {
1063 /usr/bin/sort "$@"
1065 find () {
1066 /usr/bin/find "$@"
1068 sum () {
1069 md5sum "$@"
1071 # git sees Windows-style pwd
1072 pwd () {
1073 builtin pwd -W
1075 # no POSIX permissions
1076 # backslashes in pathspec are converted to '/'
1077 # exec does not inherit the PID
1078 test_set_prereq MINGW
1079 test_set_prereq SED_STRIPS_CR
1081 *CYGWIN*)
1082 test_set_prereq POSIXPERM
1083 test_set_prereq EXECKEEPSPID
1084 test_set_prereq NOT_MINGW
1085 test_set_prereq SED_STRIPS_CR
1088 test_set_prereq POSIXPERM
1089 test_set_prereq BSLASHPSPEC
1090 test_set_prereq EXECKEEPSPID
1091 test_set_prereq NOT_MINGW
1093 esac
1095 test -z "$NO_PERL" && test_set_prereq PERL
1096 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1097 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
1099 # Can we rely on git's output in the C locale?
1100 if test -n "$GETTEXT_POISON"
1101 then
1102 GIT_GETTEXT_POISON=YesPlease
1103 export GIT_GETTEXT_POISON
1104 else
1105 test_set_prereq C_LOCALE_OUTPUT
1108 # Use this instead of test_cmp to compare files that contain expected and
1109 # actual output from git commands that can be translated. When running
1110 # under GETTEXT_POISON this pretends that the command produced expected
1111 # results.
1112 test_i18ncmp () {
1113 test -n "$GETTEXT_POISON" || test_cmp "$@"
1116 # Use this instead of "grep expected-string actual" to see if the
1117 # output from a git command that can be translated either contains an
1118 # expected string, or does not contain an unwanted one. When running
1119 # under GETTEXT_POISON this pretends that the command produced expected
1120 # results.
1121 test_i18ngrep () {
1122 if test -n "$GETTEXT_POISON"
1123 then
1124 : # pretend success
1125 elif test "x!" = "x$1"
1126 then
1127 shift
1128 ! grep "$@"
1129 else
1130 grep "$@"
1134 # test whether the filesystem supports symbolic links
1135 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1136 rm -f y
1138 # When the tests are run as root, permission tests will report that
1139 # things are writable when they shouldn't be.
1140 test -w / || test_set_prereq SANITY